package com.ynet.life.controller;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.session.Session;
import com.ynet.gene.web.servlet.ModelAndView;
import com.ynet.gene.web.servlet.mvc.GENERequestController;
import com.ynet.life.base.Trace;
import com.ynet.life.log.LifeActionLoggerFactory;
import java.util.Enumeration;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/* loaded from: com_ynet_life_controller.jar:com/ynet/life/controller/LifeEndSessionRequestController.class */
public class LifeEndSessionRequestController extends GENERequestController {
    public ModelAndView doRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        long beginTimeStamp = System.currentTimeMillis();
        ModelAndView modelAndView = null;
        try {
            try {
                modelAndView = super.doRequest(request, response);
                Session session = (Session) request.getAttribute(GENEConstance.ATTR_SESSION);
                if (session != null) {
                    Context sessionContext = (Context) session.getAttribute(GENEConstance.ATTR_CONTEXT);
                    LifeActionLoggerFactory.checkActionLogger(this.flowDef, sessionContext, (Throwable) null);
                }
                endRequest(modelAndView, request, System.currentTimeMillis() - beginTimeStamp);
                return modelAndView;
            } catch (Exception ex) {
                throw ex;
            }
        } catch (Throwable th) {
            Session session2 = (Session) request.getAttribute(GENEConstance.ATTR_SESSION);
            if (session2 != null) {
                Context sessionContext2 = (Context) session2.getAttribute(GENEConstance.ATTR_CONTEXT);
                LifeActionLoggerFactory.checkActionLogger(this.flowDef, sessionContext2, (Throwable) null);
            }
            throw th;
        }
    }

    public void endRequest(ModelAndView mv, HttpServletRequest request, long timeUsed) {
        String sessionId;
        if (this.openMonitor) {
            this.accessInfo.endAccess(timeUsed);
        }
        Session session = this.sessionManager.getSession(request, (Object) null, false);
        Session session2 = session;
        if (session == null && (sessionId = request.getParameter(GENEConstance.GENE_SESSION_ID_LABEL)) != null) {
            session2 = (Session) this.sessionManager.getSessions().get(sessionId);
        }
        if (session2 == null) {
            return;
        }
        this.sessionManager.removeSession(session2);
        Context sessionContext = (Context) session2.getAttribute(GENEConstance.ATTR_CONTEXT);
        if (sessionContext != null) {
            sessionContext.unChain();
        }
        Enumeration attrNames = session2.getAttributeNames();
        while (attrNames.hasMoreElements()) {
            String attrName = (String) attrNames.nextElement();
            session2.removeAttribute(attrName);
        }
        if (mv == null || mv.getModel() == null) {
            return;
        }
        try {
            Context context = (Context) mv.getModel().get(GENEConstance.ATTR_CONTEXT);
            if (context != null && context != sessionContext) {
                context.terminate();
            }
        } catch (Exception e) {
            Trace.logError("LifeSession", "Failed to end request of " + toString(), e);
        }
    }
}
